#!perl

my $prefix = "/usr/local/parrot";
if (@ARGV && $ARGV[0] =~ /^--prefix=(.*)/) {
    $prefix = $1;
    shift;
}

my %FILES; # { package => file }
while(<>) {
    chomp;
    my ($meta, $file, $dest) = split(/\s+/, $_);
    $dest ||= $file;
    my $generated = $meta =~ s/^\*//;
    my ($package) = $meta =~ /\[(.*?)\]/;
    next if $package eq "";
    $meta =~ s/\[.*?\]//;
    my %options;
    @options{split(/,/, $meta)} = ();
    $options{$_} = 1 for (keys %options); # Laziness

    my $entry = "";
    $entry .= "%doc " if $options{doc};
    $entry .= "%prefix/$dest";

    push @{ $FILES{$package} }, $entry;
}

while (my ($package, $files) = each %FILES) {
    my $manifest = "MANIFEST.$package";
    open(MANIFEST, ">$manifest") or die "create $manifest: $!";
    print MANIFEST "$_\n" foreach (@$files);
    close MANIFEST;
    print "Wrote $manifest\n";
}
